class FrechetMean(Model) :
    "Find the Frechet mean of a population of polygons."
    def __init__(self, guess, p=2) :
        "Defines an initial guess and the Frechet exponent."
        super(Model, self).__init__()
        self.x = Parameter(guess)
        self.p = p

    def __call__(self) :
        "Returns the current guess."
        return self.x
    
    def cost(self, targets) :
        "Returns the mean p-distance to the current guess."
        return ( arc(targets, self())**self.p ).mean()
    
# Initial guess: any non-degenerate triangle should be ok
A0 = A_k[0].float()

FMean   = FrechetMean( A0, p=2 ) 
FMean.fit(   A_k )

# For a clean display, let's normalize everybody
mean   = normalize( FMean()  )
a_k    = normalize( A_k      )

plt.figure()
#plot_worms( a_k[:10] , "green")
plot_worms( mean,      "red")
plt.axis("equal")
plt.show()
